mirror of
https://github.com/prdlk/leetcode.git
synced 2026-11-04 05:37:38 +00:00
feat: refactored docs structure
This commit is contained in:
1 parent
d388b3000e
commit
9de25fecff
212 files changed
+641
-4169
No files matched your search
@@ -0,0 +1,54 @@
|
||||
---
|
||||
title: '435. Non-overlapping Intervals'
|
||||
description: Given an array of intervals intervals where intervals[i] = [starti, endi], return the minimum number of intervals you need to remove to make the rest of the intervals non-overlapping
|
||||
icon: dot
|
||||
topics:
|
||||
- { name: "Array", slug: "array" }
|
||||
- { name: "Dynamic Programming", slug: "dynamic-programming" }
|
||||
- { name: "Greedy", slug: "greedy" }
|
||||
- { name: "Sorting", slug: "sorting" }
|
||||
issue: "https://github.com/prdlk/leetcode/issues/183"
|
||||
sidebar:
|
||||
label: 'Non-overlapping Intervals'
|
||||
badge: 'Medium'
|
||||
---
|
||||
|
||||
### Example 1:
|
||||
- Input: `intervals = [[1,2],[2,3],[3,4],[1,3]]`
|
||||
- Output: `1`
|
||||
- Explanation: `[1,3]` can be removed and the rest of the `intervals` are non-overlapping.
|
||||
|
||||
### Example 2:
|
||||
- Input: `intervals = [[1,2],[1,2],[1,2]]`
|
||||
- Output: `2`
|
||||
- Explanation: You need to remove two `[1,2]` to make the rest of the `intervals` non-overlapping.
|
||||
|
||||
### Example 3:
|
||||
- Input: `intervals = [[1,2],[2,3]]`
|
||||
- Output: `0`
|
||||
- Explanation: You don't need to remove any of the `intervals` since they're already non-overlapping.
|
||||
|
||||
### Constraints:
|
||||
|
||||
- `1 <= intervals.length <= 10^5`
|
||||
- `intervals[i].length == 2`
|
||||
- `-5 * 10^4 <= starti < endi <= 5 * 10^4`
|
||||
|
||||
## Solution
|
||||
|
||||
```py
|
||||
class Solution:
|
||||
def eraseOverlapIntervals(self, intervals: list[list[int]]) -> int:
|
||||
intervals.sort(key=lambda x: x[0])
|
||||
result = []
|
||||
|
||||
for start, end in intervals:
|
||||
# Use '<' to avoid intervals which touch
|
||||
if result and start < result[-1][1]:
|
||||
result[-1][1] = min(result[-1][1], end)
|
||||
else:
|
||||
result.append([start, end])
|
||||
|
||||
# Difference between original and result is to remove
|
||||
return len(intervals) - len(result)
|
||||
```
|
||||
@@ -0,0 +1,51 @@
|
||||
---
|
||||
title: '56. Merge Intervals'
|
||||
description: Given an array of intervals where intervals[i] = [starti, endi], merge all overlapping intervals, and return an array of the non-overlapping intervals that cover all the intervals in the input
|
||||
icon: dot
|
||||
topics:
|
||||
- { name: "Array", slug: "array" }
|
||||
- { name: "Sorting", slug: "sorting" }
|
||||
- { name: "Quicksort", slug: "quicksort" }
|
||||
issue: "https://github.com/prdlk/leetcode/issues/182"
|
||||
sidebar:
|
||||
label: 'Merge Intervals'
|
||||
badge: 'Medium'
|
||||
---
|
||||
|
||||
### Example 1:
|
||||
- Input: `intervals = [[1,3],[2,6],[8,10],[15,18]]`
|
||||
- Output: `[[1,6],[8,10],[15,18]]`
|
||||
- Explanation: Since `intervals [1,3]` and `[2,6]` overlap, merge them into `[1,6]`.
|
||||
|
||||
### Example 2:
|
||||
- Input: `intervals = [[1,4],[4,5]]`
|
||||
- Output: `[[1,5]]`
|
||||
- Explanation: Intervals `[1,4]` and `[4,5]` are considered overlapping.
|
||||
|
||||
### Example 3:
|
||||
- Input: `intervals = [[4,7],[1,4]]`
|
||||
- Output: `[[1,7]]`
|
||||
- Explanation: Intervals `[1,4]` and `[4,7]` are considered overlapping.
|
||||
|
||||
### Constraints:
|
||||
|
||||
- `1 <= intervals.length <= 10^4`
|
||||
- `intervals[i].length == 2`
|
||||
- `0 <= starti <= endi <= 10^4`
|
||||
|
||||
## Solution
|
||||
|
||||
```py
|
||||
class Solution:
|
||||
def merge(self, intervals: list[list[int]]) -> list[list[int]]:
|
||||
intervals.sort(key=lambda x: x[0])
|
||||
result = []
|
||||
|
||||
for start, end in intervals:
|
||||
if result and start <= result[-1][1]:
|
||||
result[-1][1] = max(result[-1][1], end)
|
||||
else:
|
||||
result.append([start, end])
|
||||
|
||||
return result
|
||||
```
|
||||
@@ -0,0 +1,57 @@
|
||||
---
|
||||
title: '57. Insert Interval'
|
||||
description: You are given an array of non-overlapping intervals intervals where intervals[i] = [starti, endi] represent the start and the end of the i^th interval and intervals is sorted in ascending order by starti. You are also given an interval newInterval = [start, end] that represents the start and end of another interval
|
||||
icon: dot
|
||||
topics:
|
||||
- { name: "Array", slug: "array" }
|
||||
issue: "https://github.com/prdlk/leetcode/issues/181"
|
||||
sidebar:
|
||||
label: 'Insert Interval'
|
||||
badge: 'Medium'
|
||||
---
|
||||
|
||||
### Example 1:
|
||||
- Input: `intervals = [[1,3],[6,9]], newInterval = [2,5]`
|
||||
- Output: `[[1,5],[6,9]]`
|
||||
|
||||
### Example 2:
|
||||
- Input: `intervals = [[1,2],[3,5],[6,7],[8,10],[12,16]], newInterval = [4,8]`
|
||||
- Output: `[[1,2],[3,10],[12,16]]`
|
||||
- Explanation: Because the new interval `[4,8]` overlaps with [3,5],[6,7],[8,10].
|
||||
|
||||
### Constraints:
|
||||
|
||||
- `0 <= intervals.length <= 10^4`
|
||||
- `intervals[i].length == 2`
|
||||
- `0 <= starti <= endi <= 10^5`
|
||||
- intervals is sorted by starti in ascending order.
|
||||
- `newInterval.length == 2`
|
||||
- `0 <= start <= end <= 10^5`
|
||||
|
||||
## Solution
|
||||
|
||||
```py
|
||||
class Solution:
|
||||
def insert(
|
||||
self, intervals: list[list[int]], newInterval: list[int]
|
||||
) -> list[list[int]]:
|
||||
result = []
|
||||
i, n = 0, len(intervals)
|
||||
start, end = newInterval
|
||||
|
||||
# Everything before
|
||||
while i < n and intervals[i][1] < start:
|
||||
result.append(intervals[i])
|
||||
i += 1
|
||||
|
||||
# Everything merged
|
||||
while i < n and intervals[i][0] <= end:
|
||||
start = min(start, intervals[i][0])
|
||||
end = max(end, intervals[i][1])
|
||||
i += 1
|
||||
result.append([start, end])
|
||||
|
||||
# Everything after
|
||||
result.extend(intervals[i:])
|
||||
return result
|
||||
```
|
||||
Reference in new issue
Block a user